<script setup lang="ts">
  import { Swiper, SwiperSlide } from 'swiper/vue';
  import { CmsElementImageGallery } from '@shopware-pwa/composables-next';
  import { FreeMode, Navigation, Thumbs, Mousewheel } from 'swiper/modules';
  import { Media, ProductMedia } from '@shopware-pwa/types';
  import { getSmallestThumbnailUrl, getSrcSetForMedia } from '@shopware-pwa/helpers-next';
  import { SwiperOptions } from 'swiper/types';

  type SlideItem = {
    url: null | string;
    newTab: boolean;
    media: Media;
  };

  type ImageProps = ProductMedia | string | SlideItem;

  const props = withDefaults(
    defineProps<{
      images: ImageProps[];
      config?: CmsElementImageGallery['config'];
      cms?: boolean;
    }>(),
    {
      config: undefined,
    },
  );

  const mainImages = ref<ImageProps[]>([]);
  const thumbsSwiper = ref<typeof Swiper>();
  const gallerySwiper = ref<typeof Swiper>();

  const galleryAttrs = computed<any>(() => {
    const temp: SwiperOptions = {
      modules: [FreeMode, Navigation, Thumbs],
      loop: true,
      slidesPerView: 1,
      setWrapperSize: true,
      spaceBetween: 8,
    };
    return temp;
  });

  const thumbsAttrs = computed<any>(() => {
    const temp: SwiperOptions = {
      modules: [FreeMode, Navigation, Thumbs, Mousewheel],
      slidesPerView: 'auto',
      spaceBetween: 12,
      freeMode: true,
      watchSlidesProgress: true,
      mousewheel: true,
      cssMode: true,
    };
    return temp;
  });

  const galleryPosition = computed(() => {
    return props.config?.galleryPosition?.value ?? 'left';
  });

  const setThumbsSwiper = (swiper: any) => {
    thumbsSwiper.value = swiper;
  };

  const slideNext = () => {
    gallerySwiper.value?.$el.swiper.slideNext();
  };

  const slidePrev = () => {
    gallerySwiper.value?.$el.swiper.slidePrev();
  };

  const getImage = (imageObj: ImageProps) => {
    if (typeof imageObj === 'string') {
      return imageObj;
    }
    return getSrcSetForMedia(imageObj.media) || imageObj.media?.url || '';
  };

  const getThumbImage = (imageObj: ImageProps) => {
    if (typeof imageObj === 'string') {
      return imageObj;
    }
    return getSmallestThumbnailUrl(imageObj.media) || imageObj.media?.url || '';
  };

  watch(
    () => props.images,
    async () => {
      mainImages.value = [];
      if (props.images?.length) {
        await nextTick();
        mainImages.value = props.images;
        gallerySwiper.value?.$el.swiper.updateSlides();
        thumbsSwiper.value?.updateSlides();
      }
    },
    {
      immediate: true,
    },
  );
</script>
<template>
  <div
    :class="[
      'relative flex gap-2 md:gap-3',
      galleryPosition === 'left' ? 'flex-row flex-row-reverse' : 'flex-col',
    ]"
  >
    <div
      :class="[
        'border-border relative rounded-md border',
        galleryPosition === 'left' && 'min-w-0 flex-1',
      ]"
      :style="{
        height: config?.displayMode?.value !== 'standard' ? config?.minHeight?.value : 'auto',
      }"
    >
      <Swiper
        ref="gallerySwiper"
        class="h-full w-full"
        v-bind="galleryAttrs"
        :thumbs="{
          swiper: thumbsSwiper,
        }"
      >
        <SwiperSlide
          v-for="(image, index) of mainImages"
          :key="index"
          :class="['h-auto', { 'aspect-square': !cms }]"
        >
          <img v-if="!cms" class="h-full w-full object-contain" :srcset="getImage(image)" />
          <CmsElementImage
            v-else
            :class="{
              'h-full': true,
              'flex flex-col': config?.displayMode?.value === 'standard',
              'justify-end':
                config?.displayMode?.value === 'standard' &&
                config?.verticalAlign?.value === 'flex-end',
              'justify-start':
                config?.displayMode?.value === 'standard' &&
                config?.verticalAlign?.value === 'flex-start',
              'justify-center':
                config?.displayMode?.value === 'standard' &&
                config?.verticalAlign?.value === 'center',
            }"
            :content="{ data: image, config }"
          />
        </SwiperSlide>
      </Swiper>
      <div v-if="mainImages.length > 1" class="z-9 absolute bottom-3 left-3 flex gap-2">
        <button
          class="border-border hover:enabled:bg-interactive-hover active:enabled:bg-interactive-pressed disabled:text-information-disabled h-8.5 w-8.5 flex items-center justify-center rounded-md border bg-white"
          @click="slidePrev"
        >
          <span class="i-sw-solid:chevron-left-s text-base" />
        </button>
        <button
          class="border-border hover:enabled:bg-interactive-hover active:enabled:bg-interactive-pressed disabled:text-information-disabled h-8.5 w-8.5 flex items-center justify-center rounded-md border bg-white"
          @click="slideNext"
        >
          <span class="i-sw-solid:chevron-right-s text-base" />
        </button>
      </div>
    </div>
    <div :class="[galleryPosition === 'left' && 'h-120']" class="hidden md:block">
      <Swiper
        :direction="galleryPosition === 'left' ? 'vertical' : 'horizontal'"
        class="h-full w-full"
        name="gallery-thumbs"
        v-bind="thumbsAttrs"
        @swiper="setThumbsSwiper"
      >
        <SwiperSlide
          v-for="(image, index) of mainImages"
          :key="index"
          class="border-border h-24! w-24! cursor-pointer rounded-md border"
        >
          <img :key="index" class="h-full w-full object-contain" :src="getThumbImage(image)" />
        </SwiperSlide>
      </Swiper>
    </div>
  </div>
</template>
<style scoped>
  .swiper-slide-thumb-active {
    @apply border-primary border-2;
  }
  .swiper-thumbs {
    position: relative;
    &:after {
      @apply pointer-events-none absolute z-10 h-24 w-24 content-[''];
    }
  }
  .swiper-horizontal.swiper-thumbs {
    &:after {
      @apply right-0 top-0;
      background: linear-gradient(270deg, #fff 0%, rgba(255, 255, 255, 0) 100%);
    }
  }
  .swiper-vertical.swiper-thumbs {
    &:after {
      @apply bottom-0 left-0;
      background: linear-gradient(0deg, #fff 0%, rgba(255, 255, 255, 0) 100%);
    }
  }
</style>
